// TODO: make this class based, maybe?

exports.cli = {
  _func: {
    desc: 'Test CLI',
    run: () => {
      console.log('👋  Hello!');
    }
  },

  gen: {
    screen: {
      _func: {
        desc: 'Generate a screen',
        run: generateScreen,
        arg: {
          required : true,
          desc : 'screen_name'
        }
      }
    },
    component: {
      _func: {
        desc: 'Generate a component',
        run: generateComponent,
        arg: {
          required : true,
          desc : 'component_name'
        }
      }
    }
  }
}

function generateScreen(Filament, flags, arg) {
  if (Filament.checkIfExists('app/screens/' + arg)) {
    Filament.exit('Screen ' + arg + ' already exists.');
  }

  Filament.askList('Connect the screen to Redux?', ['Yes', 'No'], (res) => {
    let isRedux = 'redux';
    if (res === 'No') {
      isRedux = 'noredux';
    }

    Filament.createDir('app/screens/' + arg);
    Filament.createFile('app/screens/' + arg + '/index.js', 'ScreenOrComp-' + isRedux + '/index.js', {
      name: arg,
      path: 'screens',
      isScreen: true
    });
    Filament.createFile('app/screens/' + arg + '/styles.js', 'ScreenOrComp-' + isRedux + '/styles.js', {
      name: arg,
      path: 'screens',
      isScreen: true
    });

    // add to the screens config file
    Filament.regexWrite(
      'app/config/screens.js',
      new RegExp('(import .* from .*;\n(?!import .* from \'app/screens/.*\';))'),
      '$1import ' + arg + ' from \'app/screens/' + arg + '\';\n'
    );

    Filament.regexWrite(
      'app/config/screens.js',
      new RegExp('(export {(\n*.*)*)\n*};'),
      '$1,\n  ' + arg + '\n};'
    );
  });
}

function generateComponent(Filament, flags, arg) {
  if (Filament.checkIfExists('app/components/' + arg)) {
    Filament.exit('Component ' + arg + ' already exists.');
  }

  Filament.askList('Connect the component to Redux?', ['Yes', 'No'], (res) => {
    let isRedux = 'redux';
    if (res === 'No') {
      isRedux = 'noredux';
    }

    Filament.createDir('app/components/' + arg);
    Filament.createFile('app/components/' + arg + '/index.js', 'ScreenOrComp-' + isRedux + '/index.js', {
      name: arg,
      path: 'components'
    });
    Filament.createFile('app/components/' + arg + '/styles.js', 'ScreenOrComp-' + isRedux + '/styles.js', {
      name: arg,
      path: 'components'
    });
  });
}
