/*
 * app/{{path}}/{{name}}
 */

// import react and react-native elements
import React, { PropTypes, Component } from 'react';
import { 
  View,
  Text
} from 'react-native';

// import redux functions to connect controller to app state
import { bindActionCreators } from 'redux';
import { connect } from 'react-redux';

// import {{path}} styles
import styles from './styles';

class {{name}} extends Component {
  constructor(props) {
		super(props);
    // do initialisation stuff here
    // this.props.sample is equal to the Sample namespace in Redux due to mapStateToProps
	}

  render() {
    return (
      <View style={styles.container}>
        <Text style={styles.text}>Hello from {{name}}!</Text>
      </View>
    );
  }
}

// map class.props.x to app state
const mapStateToProps = state => ({
  // sampleStuff: state.Sample
});

// bind actions to class
// import your redux actions above and bind here
const mapDispatchToProps = dispatch => ({
	// SampleActions: bindActionCreators(SampleActions, dispatch)
});

// export the connect function
export default connect(mapStateToProps, mapDispatchToProps)({{name}});